/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-moveit-msgs-0.4.0-0oneiric-20140821-2022/srv/QueryPlannerInterfaces.srv
 *
 */


#ifndef MOVEIT_MSGS_MESSAGE_QUERYPLANNERINTERFACESRESPONSE_H
#define MOVEIT_MSGS_MESSAGE_QUERYPLANNERINTERFACESRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <moveit_msgs/PlannerInterfaceDescription.h>

namespace moveit_msgs
{
template <class ContainerAllocator>
struct QueryPlannerInterfacesResponse_
{
  typedef QueryPlannerInterfacesResponse_<ContainerAllocator> Type;

  QueryPlannerInterfacesResponse_()
    : planner_interfaces()  {
    }
  QueryPlannerInterfacesResponse_(const ContainerAllocator& _alloc)
    : planner_interfaces(_alloc)  {
    }



   typedef std::vector< ::moveit_msgs::PlannerInterfaceDescription_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::moveit_msgs::PlannerInterfaceDescription_<ContainerAllocator> >::other >  _planner_interfaces_type;
  _planner_interfaces_type planner_interfaces;




  typedef boost::shared_ptr< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct QueryPlannerInterfacesResponse_

typedef ::moveit_msgs::QueryPlannerInterfacesResponse_<std::allocator<void> > QueryPlannerInterfacesResponse;

typedef boost::shared_ptr< ::moveit_msgs::QueryPlannerInterfacesResponse > QueryPlannerInterfacesResponsePtr;
typedef boost::shared_ptr< ::moveit_msgs::QueryPlannerInterfacesResponse const> QueryPlannerInterfacesResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace moveit_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'household_objects_database_msgs': ['/opt/ros/groovy/share/household_objects_database_msgs/cmake/../msg'], 'shape_msgs': ['/opt/ros/groovy/share/shape_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'moveit_msgs': ['/tmp/buildd/ros-groovy-moveit-msgs-0.4.0-0oneiric-20140821-2022/obj-x86_64-linux-gnu/devel/share/moveit_msgs/msg', '/tmp/buildd/ros-groovy-moveit-msgs-0.4.0-0oneiric-20140821-2022/msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'object_recognition_msgs': ['/opt/ros/groovy/share/object_recognition_msgs/cmake/../msg'], 'octomap_msgs': ['/opt/ros/groovy/share/octomap_msgs/cmake/../msg'], 'manipulation_msgs': ['/opt/ros/groovy/share/manipulation_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "acd3317a4c5631f33127fb428209db05";
  }

  static const char* value(const ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xacd3317a4c5631f3ULL;
  static const uint64_t static_value2 = 0x3127fb428209db05ULL;
};

template<class ContainerAllocator>
struct DataType< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "moveit_msgs/QueryPlannerInterfacesResponse";
  }

  static const char* value(const ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
PlannerInterfaceDescription[] planner_interfaces\n\
\n\
\n\
================================================================================\n\
MSG: moveit_msgs/PlannerInterfaceDescription\n\
# The name of the planner interface\n\
string name\n\
\n\
# The names of the planner ids within the interface\n\
string[] planner_ids\n\
";
  }

  static const char* value(const ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.planner_interfaces);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct QueryPlannerInterfacesResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::moveit_msgs::QueryPlannerInterfacesResponse_<ContainerAllocator>& v)
  {
    s << indent << "planner_interfaces[]" << std::endl;
    for (size_t i = 0; i < v.planner_interfaces.size(); ++i)
    {
      s << indent << "  planner_interfaces[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::moveit_msgs::PlannerInterfaceDescription_<ContainerAllocator> >::stream(s, indent + "    ", v.planner_interfaces[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // MOVEIT_MSGS_MESSAGE_QUERYPLANNERINTERFACESRESPONSE_H
